###################################################
### chunk number 1: options
###################################################
#line 57 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
options(prompt = "R> ", continue = "+  ", width = 80, digits=4, useFancyQuotes = FALSE)


###################################################
### chunk number 2: library
###################################################
#line 186 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
library("CDVine")


###################################################
### chunk number 3: seed
###################################################
#line 213 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 4: BiCopCDFPDF
###################################################
#line 341 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
u1 = seq(0.02,0.98,by=0.02)
u2 = seq(0.02,0.98,by=0.02)
copCDF = matrix(0,49,49)
copPDF = matrix(0,49,49)
for(i in 1:49) for(j in 1:49) copCDF[i,j] = BiCopCDF(u1=u1[i],u2=u2[j],family=2,par=0.7,par2=4)
for(i in 1:49) for(j in 1:49) copPDF[i,j] = BiCopPDF(u1=u1[i],u2=u2[j],family=2,par=0.7,par2=4)


###################################################
### chunk number 5: BiCopCDFPDFPlot
###################################################
#line 352 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
par(mfrow=c(1,2),cex.axis=0.7,cex.lab=0.9)
persp(u1,u2,copCDF,theta=-25,main="Copula CDF",ticktype="detailed",zlab="",nticks=9)
persp(u1,u2,copPDF,theta=-25,main="Copula PDF",ticktype="detailed",zlab="",nticks=9)


###################################################
### chunk number 6: BiCopHfunc
###################################################
#line 369 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
BiCopHfunc(u1=0.7, u2=0.4, family=5, par=6)


###################################################
### chunk number 7: BiCopPar2Tau
###################################################
#line 379 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
tau1=BiCopPar2Tau(family=1,par=0.7)
BiCopTau2Par(family=1,tau=tau1)


###################################################
### chunk number 8: BiCopPar2TailDep
###################################################
#line 388 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
BiCopPar2TailDep(family=7,par=0.8,par2=1.5)


###################################################
### chunk number 9: BiCopSim-seed
###################################################
#line 406 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 10: BiCopSim
###################################################
#line 409 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
dat0 = BiCopSim(N=500,family=3,par=BiCopTau2Par(family=3,tau=0.5))
dat90 = BiCopSim(N=500,family=23,par=BiCopTau2Par(family=23,tau=-0.5))
dat180 = BiCopSim(N=500,family=13,par=BiCopTau2Par(family=13,tau=0.5))
dat270 = BiCopSim(N=500,family=33,par=BiCopTau2Par(family=33,tau=-0.5))


###################################################
### chunk number 11: BiCopSimPlot
###################################################
#line 420 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
par(mfrow=c(1,4),cex.main=3,cex.lab=2,cex.axis=2)
plot(dat0, main="0 degrees", xlab="u1", ylab="u2")
plot(dat90, main="90 degrees", xlab="u1", ylab="u2")
plot(dat180, main="180 degrees", xlab="u1", ylab="u2")
plot(dat270, main="270 degrees", xlab="u1", ylab="u2")


###################################################
### chunk number 12: BiCopMetaContour-seed
###################################################
#line 474 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 13: BiCopMetaContour eval=FALSE
###################################################
## #line 477 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
## dat = BiCopSim(N=1000,family=4,par=2)
## BiCopMetaContour(u1=dat[,1],u2=dat[,2],bw=2,size=100,levels=c(0.01,0.05,0.1,0.15,0.2),par=0,family="emp",main="Empirical with N=1000")
## BiCopMetaContour(u1=NULL,u2=NULL,bw=1,size=100,levels=c(0.01,0.05,0.1,0.15,0.2),family=4,par=2,main="Standard normal margins")
## BiCopMetaContour(u1=NULL,u2=NULL,bw=1,size=100,family=4,par=2,margins="gamma",margins.par=c(1.5,0.75),levels = c(0.005,0.01,0.03,0.05,0.07,0.09),main="Gamma margins")           


###################################################
### chunk number 14: plotBiCopMetaContour
###################################################
#line 487 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
#line 477 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw#from line#487#"
par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
dat = BiCopSim(N=1000,family=4,par=2)
BiCopMetaContour(u1=dat[,1],u2=dat[,2],bw=2,size=100,levels=c(0.01,0.05,0.1,0.15,0.2),par=0,family="emp",main="Empirical with N=1000")
BiCopMetaContour(u1=NULL,u2=NULL,bw=1,size=100,levels=c(0.01,0.05,0.1,0.15,0.2),family=4,par=2,main="Standard normal margins")
BiCopMetaContour(u1=NULL,u2=NULL,bw=1,size=100,family=4,par=2,margins="gamma",margins.par=c(1.5,0.75),levels = c(0.005,0.01,0.03,0.05,0.07,0.09),main="Gamma margins")           
#line 488 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"


###################################################
### chunk number 15: BiCopLambda-seed
###################################################
#line 531 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 16: BiCopLambda eval=FALSE
###################################################
## #line 534 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## dat = BiCopSim(N=1000,family=6,par=2)
## par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
## BiCopLambda(u1=dat[,1],u2=dat[,2])
## BiCopLambda(family=6,par=2)
## BiCopLambda(u1=dat[,1],u2=dat[,2],family=6,par=2)         


###################################################
### chunk number 17: plotBiCopLambda
###################################################
#line 544 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
#line 534 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw#from line#544#"
dat = BiCopSim(N=1000,family=6,par=2)
par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
BiCopLambda(u1=dat[,1],u2=dat[,2])
BiCopLambda(family=6,par=2)
BiCopLambda(u1=dat[,1],u2=dat[,2],family=6,par=2)         
#line 545 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"


###################################################
### chunk number 18: BiCopGofKendall
###################################################
#line 582 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
gof = BiCopGofKendall(u1=dat[,1],u2=dat[,2],family=5)
gof$p.value.CvM 
gof$p.value.KS


###################################################
### chunk number 19: BiCopVuongClarke eval=FALSE
###################################################
## #line 645 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## BiCopVuongClarke(u1, u2, familyset, correction, level)


###################################################
### chunk number 20: BiCopSelect
###################################################
#line 667 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
cop1 = BiCopSelect(u1=dat[,1],u2=dat[,2],familyset=NA,indeptest=TRUE,level=0.05)
cop1$family
cop1$par


###################################################
### chunk number 21: BiCopEst-seed
###################################################
#line 703 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 22: BiCopEst
###################################################
#line 706 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
dat = BiCopSim(N=1000,family=1,par=0.7)
BiCopEst(u1=dat[,1], u2=dat[,2], family=1, method="mle", se=TRUE)
BiCopEst(u1=dat[,1], u2=dat[,2], family=2, method="mle", se=TRUE, max.df=30)


###################################################
### chunk number 23: CVineExample
###################################################
#line 762 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
type = 1
family = c(1,3,6,2,1,5)
par = c(0.5,1.3,2.1,-0.3,0.2,1.7)
par2 = c(0,0,0,3,0,0)


###################################################
### chunk number 24: CDVinePar2Tau
###################################################
#line 775 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
CDVinePar2Tau(family=family,par=par,par2=par2)


###################################################
### chunk number 25: CDVineSim-seed
###################################################
#line 784 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
set.seed(10)


###################################################
### chunk number 26: CVineSim
###################################################
#line 787 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
dat = CDVineSim(N=500, family=family, par=par, par2=par2, type=type)
head(dat)


###################################################
### chunk number 27: CVineCopSelect eval=FALSE
###################################################
## #line 803 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineCopSelect(data, familyset, type, selectioncrit, indeptest, level)


###################################################
### chunk number 28: CDVineSeqEst eval=FALSE
###################################################
## #line 820 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineSeqEst(data, family, type, method, se, max.df, max.BB)


###################################################
### chunk number 29: CDVineLogLik eval=FALSE
###################################################
## #line 848 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineLogLik(data, family, par, par2, type)


###################################################
### chunk number 30: CDVineMLE eval=FALSE
###################################################
## #line 861 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineMLE(data, family, start, start2, type, maxit, max.df, max.BB)


###################################################
### chunk number 31: CDVineVuongTest eval=FALSE
###################################################
## #line 883 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineVuongTest(data, Model1.order, Model2.order, Model1.family, Model2.family, Model1.par, Model2.par, Model1.par2, Model2.par2, Model1.type, Model2.type)


###################################################
### chunk number 32: CDVineTreePlot eval=FALSE
###################################################
## #line 905 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## CDVineTreePlot(data, family, par, par2, names, type, method, max.df, max.BB, tree, edge.labels, P)


###################################################
### chunk number 33: data
###################################################
#line 951 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
data(worldindices)


###################################################
### chunk number 34: EDA_pairs eval=FALSE
###################################################
## #line 960 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## panel.contour <- function(x, y, bw=2, size=100)
## {
##     usr <- par("usr")
##     on.exit(par(usr))
##     par(usr = c(-3,3,-3,3), new=TRUE)
## 
##     BiCopMetaContour(x, y, bw, size, axes=FALSE)
## }
## 
## pairs(worldindices, lower.panel=panel.contour, gap=0) 


###################################################
### chunk number 35: EDA_pairs_plot
###################################################
#line 975 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
#line 960 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw#from line#975#"
panel.contour <- function(x, y, bw=2, size=100)
{
    usr <- par("usr")
    on.exit(par(usr))
    par(usr = c(-3,3,-3,3), new=TRUE)

    BiCopMetaContour(x, y, bw, size, axes=FALSE)
}

pairs(worldindices, lower.panel=panel.contour, gap=0) 
#line 976 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"


###################################################
### chunk number 36: EDA_graphical eval=FALSE
###################################################
## #line 1000 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
## BiCopKPlot(worldindices[,5],worldindices[,6],main="K-plot")
## BiCopChiPlot(worldindices[,5],worldindices[,6],xlim=c(-1,1),ylim=c(-1,1),main="Chi-plot")
## param=BiCopEst(worldindices[,5],worldindices[,6],2)
## BiCopLambda(worldindices[,5],worldindices[,6],family=2,par=param$par,par2=param$par2,main="Lambda-function")


###################################################
### chunk number 37: EDA_graphical_plot
###################################################
#line 1010 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
#line 1000 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw#from line#1010#"
par(mfrow=c(1,3),cex.main=2,cex.lab=1.5,cex.axis=1.5)
BiCopKPlot(worldindices[,5],worldindices[,6],main="K-plot")
BiCopChiPlot(worldindices[,5],worldindices[,6],xlim=c(-1,1),ylim=c(-1,1),main="Chi-plot")
param=BiCopEst(worldindices[,5],worldindices[,6],2)
BiCopLambda(worldindices[,5],worldindices[,6],family=2,par=param$par,par2=param$par2,main="Lambda-function")
#line 1011 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"


###################################################
### chunk number 38: EDA_analytical1
###################################################
#line 1031 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
BiCopIndTest(worldindices[,5],worldindices[,6])$p.value


###################################################
### chunk number 39: EDA_analytical2
###################################################
#line 1038 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
BiCopVuongClarke(worldindices[,5],worldindices[,6],familyset=c(1:10,13,14,16:20))
BiCopSelect(worldindices[,5],worldindices[,6],familyset=c(1:10,13,14,16:20))$family


###################################################
### chunk number 40: cvine
###################################################
#line 1057 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
order = c(5, 2, 6, 4, 3, 1) 
dat=worldindices[,order]
family=c(9,  2,  2, 19,  19,  0, 34,  1,  0,  0,  1,  0,  0,  4,  0)


###################################################
### chunk number 41: seqest2
###################################################
#line 1066 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
seqPar=CDVineSeqEst(dat,family=family,type=1,method="mle")


###################################################
### chunk number 42: mle
###################################################
#line 1072 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
mlePar=CDVineMLE(dat,family=family,start=seqPar$par,start2=seqPar$par2,type=1)


###################################################
### chunk number 43: options_digits1
###################################################
#line 1080 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
options(digits=6)


###################################################
### chunk number 44: loglik
###################################################
#line 1083 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
CDVineLogLik(dat,family=family,par=seqPar$par,par2=seqPar$par2,type=1)$loglik
CDVineLogLik(dat,family=family,par=mlePar$par,par2=mlePar$par2,type=1)$loglik


###################################################
### chunk number 45: options_digits2
###################################################
#line 1087 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
options(digits=4)


###################################################
### chunk number 46: tree eval=FALSE
###################################################
## #line 1095 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
## P=CDVineTreePlot(data=NULL,family=family,par=mlePar$par,par2=mlePar$par2,names=colnames(dat),type=1,tree=1,edge.labels=c("family","theotau"))


###################################################
### chunk number 47: ps.options
###################################################
#line 1098 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
ps.options(fonts=c("sans"))


###################################################
### chunk number 48: dvine
###################################################
#line 1118 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
order_dvine=c(1, 4, 5, 6, 2, 3)
dvine=CDVineCopSelect(worldindices[,order_dvine],type="DVine",indeptest=TRUE)
family_dvine=dvine$family
mle_dvine=CDVineMLE(worldindices[,order_dvine], family_dvine, type="DVine")
par_dvine=mle_dvine$par
par2_dvine=mle_dvine$par2


###################################################
### chunk number 49: options2
###################################################
#line 1127 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
options(width = 70)


###################################################
### chunk number 50: vuong
###################################################
#line 1130 "d:/Rcompile/CRANpkg/local/2.12/CDVine/inst/doc/CDVine-package.rnw"
CDVineVuongTest(worldindices, Model1.order=order,Model2.order=order_dvine, Model1.family=family, Model2.family=family_dvine, Model1.par=mlePar$par, Model2.par=par_dvine,Model1.par2=mlePar$par2,Model2.par2=par2_dvine,Model1.type=1, Model2.type=2)


